diff -uNr openmp-3.5.0.src/runtime/src/makefile.mk openmp-3.5.0.src.r219214/runtime/src/makefile.mk
--- openmp-3.5.0.src/runtime/src/makefile.mk	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/makefile.mk	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 # makefile.mk #
-# $Revision: 42820 $
-# $Date: 2013-11-13 16:53:44 -0600 (Wed, 13 Nov 2013) $
+# $Revision: 43473 $
+# $Date: 2014-09-26 15:02:57 -0500 (Fri, 26 Sep 2014) $
 
 #
 #//===----------------------------------------------------------------------===//
@@ -221,6 +221,18 @@
     endif
 endif
 
+# On Linux and Windows Intel64 we need offload attribute for all Fortran entries
+# in order to support OpenMP function calls inside Device constructs
+ifeq "$(fort)" "ifort"
+    ifeq "$(os)_$(arch)" "lin_32e"
+        # TODO: change to -qoffload... when we stop supporting 14.0 compiler (-offload is deprecated)
+        fort-flags += -offload-attribute-target=mic
+    endif
+    ifeq "$(os)_$(arch)" "win_32e"
+        fort-flags += /Qoffload-attribute-target:mic
+    endif
+endif
+
 ifeq "$(os)" "lrb"
     c-flags    += -mmic
     cxx-flags  += -mmic
@@ -361,6 +373,7 @@
         # to remove dependency on libgcc_s:
         ifeq "$(c)" "gcc"
             ld-flags-dll += -static-libgcc
+            # omp_os is non-empty only in the open-source code
             ifneq "$(omp_os)" "freebsd"
                 ld-flags-extra += -Wl,-ldl
             endif
@@ -417,11 +430,15 @@
             ld-flags += -ldl
         endif
     endif
+    # include the c++ library for stats-gathering code
+    ifeq "$(stats)" "on"
+        ld-flags-extra += -Wl,-lstdc++
+    endif
   endif
 endif
 
 ifeq "$(os)" "mac"
-    ifeq "$(c)" "icc"
+    ifeq "$(ld)" "icc"
         ld-flags += -no-intel-extensions
     endif
     ld-flags += -single_module
@@ -483,6 +500,13 @@
 cpp-flags += -D KMP_ADJUST_BLOCKTIME=1
 cpp-flags += -D BUILD_PARALLEL_ORDERED
 cpp-flags += -D KMP_ASM_INTRINS
+cpp-flags += -D KMP_USE_INTERNODE_ALIGNMENT=0
+# Linux and MIC compile with version symbols
+ifneq "$(filter lin lrb,$(os))" ""
+ifeq "$(filter ppc64,$(arch))" ""
+    cpp-flags += -D KMP_USE_VERSION_SYMBOLS
+endif
+endif
 ifneq "$(os)" "lrb"
     cpp-flags += -D USE_LOAD_BALANCE
 endif
@@ -506,43 +530,52 @@
         cpp-flags += -D KMP_GOMP_COMPAT
     endif
 endif
-
+cpp-flags += -D KMP_NESTED_HOT_TEAMS
 ifneq "$(filter 32 32e,$(arch))" ""
 cpp-flags += -D KMP_USE_ADAPTIVE_LOCKS=1 -D KMP_DEBUG_ADAPTIVE_LOCKS=0
 endif
 
+# is the std c++ library needed? (for stats-gathering, it is)
+std_cpp_lib=0
+ifneq "$(filter lin lrb,$(os))" ""
+    ifeq "$(stats)" "on"
+        cpp-flags += -D KMP_STATS_ENABLED=1
+        std_cpp_lib=1
+    else
+        cpp-flags += -D KMP_STATS_ENABLED=0
+    endif
+else # no mac or windows support for stats-gathering
+    ifeq "$(stats)" "on"
+        $(error Statistics-gathering functionality not available on $(os) platform)
+    endif
+    cpp-flags += -D KMP_STATS_ENABLED=0
+endif
+
 # define compatibility with different OpenMP versions
 have_omp_50=0
 have_omp_41=0
 have_omp_40=0
-have_omp_30=0
 ifeq "$(OMP_VERSION)" "50"
 	have_omp_50=1
 	have_omp_41=1
 	have_omp_40=1
-	have_omp_30=1
 endif
 ifeq "$(OMP_VERSION)" "41"
 	have_omp_50=0
 	have_omp_41=1
 	have_omp_40=1
-	have_omp_30=1
 endif
 ifeq "$(OMP_VERSION)" "40"
 	have_omp_50=0
 	have_omp_41=0
 	have_omp_40=1
-	have_omp_30=1
 endif
 ifeq "$(OMP_VERSION)" "30"
 	have_omp_50=0
 	have_omp_41=0
 	have_omp_40=0
-	have_omp_30=1
 endif
-cpp-flags += -D OMP_50_ENABLED=$(have_omp_50) -D OMP_41_ENABLED=$(have_omp_41)
-cpp-flags += -D OMP_40_ENABLED=$(have_omp_40) -D OMP_30_ENABLED=$(have_omp_30)
-
+cpp-flags += -D OMP_50_ENABLED=$(have_omp_50) -D OMP_41_ENABLED=$(have_omp_41) -D OMP_40_ENABLED=$(have_omp_40)
 
 # Using ittnotify is enabled by default.
 USE_ITT_NOTIFY = 1
@@ -598,8 +631,8 @@
         z_Linux_asm$(obj) : \
 			cpp-flags += -D KMP_ARCH_PPC64		    
     else
-    	z_Linux_asm$(obj) : \
-       		cpp-flags += -D KMP_ARCH_X86$(if $(filter 32e,$(arch)),_64)	
+        z_Linux_asm$(obj) : \
+		    cpp-flags += -D KMP_ARCH_X86$(if $(filter 32e,$(arch)),_64)
     endif
 endif
 
@@ -699,6 +732,8 @@
         kmp_i18n                     \
         kmp_io                       \
         kmp_runtime                  \
+        kmp_wait_release             \
+        kmp_barrier                  \
         kmp_settings                 \
         kmp_str                      \
         kmp_tasking                  \
@@ -715,6 +750,10 @@
     lib_cpp_items += kmp_taskdeps
     lib_cpp_items += kmp_cancel
 endif
+ifeq "$(stats)" "on"
+    lib_cpp_items += kmp_stats
+    lib_cpp_items += kmp_stats_timing
+endif
 
     # OS-specific files.
     ifeq "$(os)" "win"
@@ -1272,8 +1311,20 @@
         # On Linux* OS and OS X* the test is good enough because GNU compiler knows nothing
         # about libirc and Intel compiler private lib directories, but we will grep verbose linker
         # output just in case.
-        tt-c        = cc
-        ifeq "$(os)" "lin"    # GCC on OS X* does not recognize -pthread.
+        # Using clang on OS X* because of discontinued support of GNU compilers.
+        ifeq "$(os)" "mac"
+            ifeq "$(std_cpp_lib)" "1"
+                tt-c        = clang++
+            else
+                tt-c        = clang
+            endif
+        else # lin
+            ifeq "$(std_cpp_lib)" "1"
+                tt-c        = g++
+            else
+                tt-c        = gcc
+            endif
+            # GCC on OS X* does not recognize -pthread.
             tt-c-flags  += -pthread
         endif
         tt-c-flags += -o $(tt-exe-file)
@@ -1416,6 +1467,10 @@
             td_exp += libc.so.6
             td_exp += ld64.so.1
         endif
+        ifeq "$(std_cpp_lib)" "1"
+            td_exp += libstdc++.so.6
+        endif
+
         td_exp += libdl.so.2
         td_exp += libgcc_s.so.1
         ifeq "$(filter 32 32e 64 ppc64,$(arch))" ""
@@ -1428,6 +1483,9 @@
     endif
     ifeq "$(os)" "lrb"
         ifeq "$(MIC_OS)" "lin"
+            ifeq "$(std_cpp_lib)" "1"
+                td_exp += libstdc++.so.6
+            endif
             ifeq "$(MIC_ARCH)" "knf"
                 td_exp += "ld-linux-l1om.so.2"
                 td_exp += libc.so.6
@@ -1459,8 +1517,9 @@
             td_exp += uuid
         endif
     endif
+
     ifeq "$(omp_os)" "freebsd"
-        td_exp =
+        td_exp = 
         td_exp += libc.so.7
         td_exp += libthr.so.3
         td_exp += libunwind.so.5
diff -uNr openmp-3.5.0.src/runtime/src/rules.mk openmp-3.5.0.src.r219214/runtime/src/rules.mk
--- openmp-3.5.0.src/runtime/src/rules.mk	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/rules.mk	2014-10-24 19:58:41.000000000 -0400
@@ -1,6 +1,6 @@
 # rules.mk #
-# $Revision: 42423 $
-# $Date: 2013-06-07 09:25:21 -0500 (Fri, 07 Jun 2013) $
+# $Revision: 42951 $
+# $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 #
 #//===----------------------------------------------------------------------===//
diff -uNr openmp-3.5.0.src/runtime/src/test-touch.c openmp-3.5.0.src.r219214/runtime/src/test-touch.c
--- openmp-3.5.0.src/runtime/src/test-touch.c	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/test-touch.c	2014-10-24 19:58:41.000000000 -0400
@@ -11,9 +11,15 @@
 //===----------------------------------------------------------------------===//
 
 
+#ifdef __cplusplus
+extern "C" {
+#endif
 extern double omp_get_wtime();
 extern int    omp_get_num_threads();
 extern int    omp_get_max_threads();
+#ifdef __cplusplus
+}
+#endif
 
 int main() {
     omp_get_wtime();
diff -uNr openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify.h openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify.h
--- openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify.h	2014-02-24 05:40:15.000000000 -0500
+++ openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify.h	2014-10-24 19:58:41.000000000 -0400
@@ -8,7 +8,6 @@
 //
 //===----------------------------------------------------------------------===//
 
-
 #ifndef _ITTNOTIFY_H_
 #define _ITTNOTIFY_H_
 
@@ -141,7 +140,7 @@
 #  if ITT_PLATFORM==ITT_PLATFORM_WIN
 #    define CDECL __cdecl
 #  else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
-#    if defined _M_IX86 || defined __i386__
+#    if defined _M_IX86 || defined __i386__ 
 #      define CDECL __attribute__ ((cdecl))
 #    else  /* _M_IX86 || __i386__ */
 #      define CDECL /* actual only on x86 platform */
@@ -154,7 +153,7 @@
 #    define STDCALL __stdcall
 #  else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #    if defined _M_IX86 || defined __i386__
-#      define STDCALL __attribute__ ((stdcall))
+#      define STDCALL __attribute__ ((stdcall)) 
 #    else  /* _M_IX86 || __i386__ */
 #      define STDCALL /* supported only on x86 platform */
 #    endif /* _M_IX86 || __i386__ */
@@ -416,19 +415,19 @@
  *********************************************************************/
 /** @{ */
 /**
- * @hideinitializer
+ * @hideinitializer 
  * @brief possible value for suppression mask
  */
 #define __itt_suppress_all_errors 0x7fffffff
 
 /**
- * @hideinitializer
+ * @hideinitializer 
  * @brief possible value for suppression mask (suppresses errors from threading analysis)
  */
 #define __itt_suppress_threading_errors 0x000000ff
 
 /**
- * @hideinitializer
+ * @hideinitializer 
  * @brief possible value for suppression mask (suppresses errors from memory analysis)
  */
 #define __itt_suppress_memory_errors 0x0000ff00
@@ -454,7 +453,7 @@
 /** @endcond */
 
 /**
- * @brief Undo the effects of the matching call to __itt_suppress_push
+ * @brief Undo the effects of the matching call to __itt_suppress_push  
  */
 void ITTAPI __itt_suppress_pop(void);
 
@@ -1584,13 +1583,13 @@
  * @brief Specify the type of heap detection/reporting to modify.
  */
 /**
- * @hideinitializer
+ * @hideinitializer 
  * @brief Report on memory leaks.
  */
 #define __itt_heap_leaks 0x00000001
 
 /**
- * @hideinitializer
+ * @hideinitializer 
  * @brief Report on memory growth.
  */
 #define __itt_heap_growth 0x00000002
@@ -1667,7 +1666,7 @@
  * @ingroup domains
  * @brief Create a domain.
  * Create domain using some domain name: the URI naming style is recommended.
- * Because the set of domains is expected to be static over the application's
+ * Because the set of domains is expected to be static over the application's 
  * execution time, there is no mechanism to destroy a domain.
  * Any domain can be accessed by any thread in the process, regardless of
  * which thread created the domain. This call is thread-safe.
@@ -1802,7 +1801,7 @@
  * @brief Destroy an instance of identifier.
  * This ends the lifetime of the current instance of the given ID value in the trace.
  * Any relationships that are established after this lifetime ends are invalid.
- * This call must be performed before the given ID value can be reused for a different
+ * This call must be performed before the given ID value can be reused for a different 
  * named entity instance.
  * @param[in] domain The domain controlling the execution of this call.
  * @param[in] id The ID to destroy.
@@ -1926,10 +1925,10 @@
 
 /**
  * @ingroup timestamps
- * @brief Return timestamp corresponding to current moment.
- * This returns the timestamp in format that is most relevant for the current
- * host or platform.  Do not rely that it's RDTSC value.  It is possible
- * to compare __itt_timestamp values with "<" operator.
+ * @brief Return timestamp corresponding to the current moment.
+ * This returns the timestamp in the format that is the most relevant for the current
+ * host or platform (RDTSC, QPC, and others). You can use the "<" operator to
+ * compare __itt_timestamp values.
  */
 __itt_timestamp ITTAPI __itt_get_timestamp(void);
 
@@ -2053,13 +2052,13 @@
 /** @cond exclude_from_documentation */
 #ifndef INTEL_NO_MACRO_BODY
 #ifndef INTEL_NO_ITTNOTIFY_API
-ITT_STUBV(ITTAPI, void, frame_begin_v3, (const __itt_domain *domain, __itt_id *id))
-ITT_STUBV(ITTAPI, void, frame_end_v3,   (const __itt_domain *domain, __itt_id *id))
+ITT_STUBV(ITTAPI, void, frame_begin_v3,  (const __itt_domain *domain, __itt_id *id))
+ITT_STUBV(ITTAPI, void, frame_end_v3,    (const __itt_domain *domain, __itt_id *id))
 ITT_STUBV(ITTAPI, void, frame_submit_v3, (const __itt_domain *domain, __itt_id *id, __itt_timestamp begin, __itt_timestamp end))
-#define __itt_frame_begin_v3(d,x)   ITTNOTIFY_VOID_D1(frame_begin_v3,d,x)
-#define __itt_frame_begin_v3_ptr    ITTNOTIFY_NAME(frame_begin_v3)
-#define __itt_frame_end_v3(d,x)     ITTNOTIFY_VOID_D1(frame_end_v3,d,x)
-#define __itt_frame_end_v3_ptr      ITTNOTIFY_NAME(frame_end_v3)
+#define __itt_frame_begin_v3(d,x)      ITTNOTIFY_VOID_D1(frame_begin_v3,d,x)
+#define __itt_frame_begin_v3_ptr       ITTNOTIFY_NAME(frame_begin_v3)
+#define __itt_frame_end_v3(d,x)        ITTNOTIFY_VOID_D1(frame_end_v3,d,x)
+#define __itt_frame_end_v3_ptr         ITTNOTIFY_NAME(frame_end_v3)
 #define __itt_frame_submit_v3(d,x,b,e) ITTNOTIFY_VOID_D3(frame_submit_v3,d,x,b,e)
 #define __itt_frame_submit_v3_ptr      ITTNOTIFY_NAME(frame_submit_v3)
 #else  /* INTEL_NO_ITTNOTIFY_API */
@@ -2361,7 +2360,7 @@
  * @param[in] id The identifier of the instance to which the metadata is to be added, or __itt_null to add to the current task
  * @param[in] key The name of the metadata
  * @param[in] data The metadata itself
- * @param[in] length The number of characters in the string, or -1 if the length is unknown but the string is null-terminated
+ * @param[in] length The number of characters in the string, or -1 if the length is unknown but the string is null-terminated 
 */
 #if ITT_PLATFORM==ITT_PLATFORM_WIN
 void ITTAPI __itt_metadata_str_addA(const __itt_domain *domain, __itt_id id, __itt_string_handle *key, const char *data, size_t length);
@@ -2397,9 +2396,9 @@
 #endif /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #else  /* INTEL_NO_ITTNOTIFY_API */
 #if ITT_PLATFORM==ITT_PLATFORM_WIN
-#define __itt_metadata_str_addA(d,x,y,z,a)
+#define __itt_metadata_str_addA(d,x,y,z,a) 
 #define __itt_metadata_str_addA_ptr 0
-#define __itt_metadata_str_addW(d,x,y,z,a)
+#define __itt_metadata_str_addW(d,x,y,z,a) 
 #define __itt_metadata_str_addW_ptr 0
 #else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #define __itt_metadata_str_add(d,x,y,z,a)
@@ -2423,7 +2422,7 @@
  * @param[in] scope The scope of the instance to which the metadata is to be added
 
  * @param[in] id The identifier of the instance to which the metadata is to be added, or __itt_null to add to the current task
-
+ 
  * @param[in] key The name of the metadata
  * @param[in] type The type of the metadata
  * @param[in] count The number of elements of the given type. If count == 0, no metadata will be added.
@@ -2456,7 +2455,7 @@
 
  * @param[in] key The name of the metadata
  * @param[in] data The metadata itself
- * @param[in] length The number of characters in the string, or -1 if the length is unknown but the string is null-terminated
+ * @param[in] length The number of characters in the string, or -1 if the length is unknown but the string is null-terminated 
 */
 #if ITT_PLATFORM==ITT_PLATFORM_WIN
 void ITTAPI __itt_metadata_str_add_with_scopeA(const __itt_domain *domain, __itt_scope scope, __itt_string_handle *key, const char *data, size_t length);
@@ -2492,9 +2491,9 @@
 #endif /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #else  /* INTEL_NO_ITTNOTIFY_API */
 #if ITT_PLATFORM==ITT_PLATFORM_WIN
-#define __itt_metadata_str_add_with_scopeA(d,x,y,z,a)
+#define __itt_metadata_str_add_with_scopeA(d,x,y,z,a) 
 #define __itt_metadata_str_add_with_scopeA_ptr  0
-#define __itt_metadata_str_add_with_scopeW(d,x,y,z,a)
+#define __itt_metadata_str_add_with_scopeW(d,x,y,z,a) 
 #define __itt_metadata_str_add_with_scopeW_ptr  0
 #else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #define __itt_metadata_str_add_with_scope(d,x,y,z,a)
@@ -3080,9 +3079,9 @@
 
 /**
  * @enum __itt_av_data_type
- * @brief Defines types of arrays data (for C/C++ intrinsic types)
+ * @brief Defines types of arrays data (for C/C++ intrinsic types) 
  */
-typedef enum
+typedef enum 
 {
     __itt_e_first = 0,
     __itt_e_char = 0,  /* 1-byte integer */
@@ -3102,8 +3101,8 @@
  * @brief Save an array data to a file.
  * Output format is defined by the file extension. The csv and bmp formats are supported (bmp - for 2-dimensional array only).
  * @param[in] data - pointer to the array data
- * @param[in] rank - the rank of the array
- * @param[in] dimensions - pointer to an array of integers, which specifies the array dimensions.
+ * @param[in] rank - the rank of the array 
+ * @param[in] dimensions - pointer to an array of integers, which specifies the array dimensions. 
  * The size of dimensions must be equal to the rank
  * @param[in] type - the type of the array, specified as one of the __itt_av_data_type values (for intrinsic types)
  * @param[in] filePath - the file path; the output format is defined by the file extension
diff -uNr openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify_config.h openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify_config.h
--- openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify_config.h	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify_config.h	2014-10-24 19:58:41.000000000 -0400
@@ -74,7 +74,7 @@
 #  if ITT_PLATFORM==ITT_PLATFORM_WIN
 #    define CDECL __cdecl
 #  else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
-#    if defined _M_IX86 || defined __i386__
+#    if defined _M_IX86 || defined __i386__ 
 #      define CDECL __attribute__ ((cdecl))
 #    else  /* _M_IX86 || __i386__ */
 #      define CDECL /* actual only on x86 platform */
@@ -87,7 +87,7 @@
 #    define STDCALL __stdcall
 #  else /* ITT_PLATFORM==ITT_PLATFORM_WIN */
 #    if defined _M_IX86 || defined __i386__
-#      define STDCALL __attribute__ ((stdcall))
+#      define STDCALL __attribute__ ((stdcall)) 
 #    else  /* _M_IX86 || __i386__ */
 #      define STDCALL /* supported only on x86 platform */
 #    endif /* _M_IX86 || __i386__ */
@@ -267,7 +267,7 @@
 #ifdef __INTEL_COMPILER
 #define __TBB_machine_fetchadd4(addr, val) __fetchadd4_acq((void *)addr, val)
 #else  /* __INTEL_COMPILER */
-/* TODO: Add Support for not Intel compilers for IA-64 architecture */
+/* TODO: Add Support for not Intel compilers for IA-64 */
 #endif /* __INTEL_COMPILER */
 #elif ITT_ARCH==ITT_ARCH_IA32 || ITT_ARCH==ITT_ARCH_IA32E /* ITT_ARCH!=ITT_ARCH_IA64 */
 ITT_INLINE long
diff -uNr openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify_static.c openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify_static.c
--- openmp-3.5.0.src/runtime/src/thirdparty/ittnotify/ittnotify_static.c	2013-12-23 12:28:57.000000000 -0500
+++ openmp-3.5.0.src.r219214/runtime/src/thirdparty/ittnotify/ittnotify_static.c	2014-10-24 19:58:41.000000000 -0400
@@ -22,14 +22,14 @@
 #include <stdarg.h>
 #include <string.h>
 
-#define INTEL_NO_MACRO_BODY
+#define INTEL_NO_MACRO_BODY 
 #define INTEL_ITTNOTIFY_API_PRIVATE
 #include "ittnotify.h"
 #include "legacy/ittnotify.h"
 
 #include "disable_warnings.h"
 
-static const char api_version[] = API_VERSION "\0\n@(#) $Revision: 42754 $\n";
+static const char api_version[] = API_VERSION "\0\n@(#) $Revision: 43375 $\n";
 
 #define _N_(n) ITT_JOIN(INTEL_ITTNOTIFY_PREFIX,n)
 
@@ -44,13 +44,34 @@
 #endif
 
 #ifdef __ANDROID__
+#include <android/log.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+#include <linux/limits.h>
+
+#ifdef ITT_ANDROID_LOG
+    #define ITT_ANDROID_LOG_TAG   "INTEL_VTUNE_USERAPI"
+    #define ITT_ANDROID_LOGI(...) ((void)__android_log_print(ANDROID_LOG_INFO, ITT_ANDROID_LOG_TAG, __VA_ARGS__))
+    #define ITT_ANDROID_LOGW(...) ((void)__android_log_print(ANDROID_LOG_WARN, ITT_ANDROID_LOG_TAG, __VA_ARGS__))
+    #define ITT_ANDROID_LOGE(...) ((void)__android_log_print(ANDROID_LOG_ERROR,ITT_ANDROID_LOG_TAG, __VA_ARGS__))
+    #define ITT_ANDROID_LOGD(...) ((void)__android_log_print(ANDROID_LOG_DEBUG,ITT_ANDROID_LOG_TAG, __VA_ARGS__))
+#else
+    #define ITT_ANDROID_LOGI(...)
+    #define ITT_ANDROID_LOGW(...)
+    #define ITT_ANDROID_LOGE(...)
+    #define ITT_ANDROID_LOGD(...)
+#endif
+
 /* default location of userapi collector on Android */
 #define ANDROID_ITTNOTIFY_DEFAULT_PATH  "/data/data/com.intel.vtune/intel/libittnotify.so"
 #endif
 
 
 #ifndef LIB_VAR_NAME
-#if ITT_ARCH==ITT_ARCH_IA32
+#if ITT_ARCH==ITT_ARCH_IA32 || ITT_ARCH==ITT_ARCH_ARM
 #define LIB_VAR_NAME INTEL_LIBITTNOTIFY32
 #else
 #define LIB_VAR_NAME INTEL_LIBITTNOTIFY64
@@ -687,6 +708,92 @@
 {
     const char* lib_name = __itt_get_env_var(ITT_TO_STR(LIB_VAR_NAME));
 
+#ifdef __ANDROID__
+    if (lib_name == NULL)
+    {
+        const char* const system_wide_marker_filename = "/data/local/tmp/com.intel.itt.collector_lib";
+        int itt_marker_file_fd = open(system_wide_marker_filename, O_RDONLY);
+        ssize_t res = 0;
+
+        if (itt_marker_file_fd == -1)
+        {
+            const pid_t my_pid = getpid();
+            char cmdline_path[PATH_MAX] = {0};
+            char package_name[PATH_MAX] = {0};
+            char app_sandbox_file[PATH_MAX] = {0};
+            int cmdline_fd = 0;
+
+            ITT_ANDROID_LOGI("Unable to open system-wide marker file.");
+            snprintf(cmdline_path, PATH_MAX - 1, "/proc/%d/cmdline", my_pid);
+            ITT_ANDROID_LOGI("CMD file: %s\n", cmdline_path);
+            cmdline_fd = open(cmdline_path, O_RDONLY);
+            if (cmdline_fd == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to open %s file!", cmdline_path);
+                return lib_name;
+            }
+            res = read(cmdline_fd, package_name, PATH_MAX - 1);
+            if (res == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to read %s file!", cmdline_path);
+                res = close(cmdline_fd);
+                if (res == -1)
+                {
+                    ITT_ANDROID_LOGE("Unable to close %s file!", cmdline_path);
+                }
+                return lib_name;
+            }
+            res = close(cmdline_fd);
+            if (res == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to close %s file!", cmdline_path);
+                return lib_name;
+            }
+            ITT_ANDROID_LOGI("Package name: %s\n", package_name);
+            snprintf(app_sandbox_file, PATH_MAX - 1, "/data/data/%s/com.intel.itt.collector_lib", package_name);
+            ITT_ANDROID_LOGI("Lib marker file name: %s\n", app_sandbox_file);
+            itt_marker_file_fd = open(app_sandbox_file, O_RDONLY);
+            if (itt_marker_file_fd == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to open app marker file!");
+                return lib_name;
+            }
+        }
+
+        {
+            char itt_lib_name[PATH_MAX] = {0};
+
+            res = read(itt_marker_file_fd, itt_lib_name, PATH_MAX - 1);
+            if (res == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to read %s file!", itt_marker_file_fd);
+                res = close(itt_marker_file_fd);
+                if (res == -1)
+                {
+                    ITT_ANDROID_LOGE("Unable to close %s file!", itt_marker_file_fd);
+                }
+                return lib_name;
+            }
+            ITT_ANDROID_LOGI("ITT Lib path: %s", itt_lib_name);
+            res = close(itt_marker_file_fd);
+            if (res == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to close %s file!", itt_marker_file_fd);
+                return lib_name;
+            }
+            ITT_ANDROID_LOGI("Set env");
+            res = setenv(ITT_TO_STR(LIB_VAR_NAME), itt_lib_name, 0);
+            if (res == -1)
+            {
+                ITT_ANDROID_LOGE("Unable to set env var!");
+                return lib_name;
+            }
+            lib_name = __itt_get_env_var(ITT_TO_STR(LIB_VAR_NAME));
+            ITT_ANDROID_LOGI("ITT Lib path from env: %s", itt_lib_name);
+        }
+    }
+#endif
+
     return lib_name;
 }
 
diff -uNr openmp-3.5.0.src/runtime/src/z_Linux_asm.s openmp-3.5.0.src.r219214/runtime/src/z_Linux_asm.s
--- openmp-3.5.0.src/runtime/src/z_Linux_asm.s	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/z_Linux_asm.s	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 //  z_Linux_asm.s:  - microtasking routines specifically
 //                    written for Intel platforms running Linux* OS
-// $Revision: 42810 $
-// $Date: 2013-11-07 12:06:33 -0600 (Thu, 07 Nov 2013) $
+// $Revision: 43473 $
+// $Date: 2014-09-26 15:02:57 -0500 (Fri, 26 Sep 2014) $
 
 //
 ////===----------------------------------------------------------------------===//
@@ -489,118 +489,6 @@
 
 //------------------------------------------------------------------------
 //
-// FUNCTION __kmp_test_then_add_real32
-//
-// kmp_real32
-// __kmp_test_then_add_real32( volatile kmp_real32 *addr, kmp_real32 data );
-//
-
-        PROC  __kmp_test_then_add_real32
-
-_addr = 8
-_data = 12
-_old_value = -4
-_new_value = -8
-
-        pushl   %ebp
-        movl    %esp, %ebp
-        subl    $8, %esp
-        pushl   %esi
-        pushl   %ebx
-        movl    _addr(%ebp), %esi
-L22:
-        flds    (%esi)
-                        // load <addr>
-        fsts    _old_value(%ebp)
-                        // store into old_value
-        fadds   _data(%ebp)
-        fstps   _new_value(%ebp)
-                        // new_value = old_value + data
-
-        movl    _old_value(%ebp), %eax
-                        // load old_value
-        movl    _new_value(%ebp), %ebx
-                        // load new_value
-
-	lock
-	cmpxchgl %ebx,(%esi)
-                        // Compare %EAX with <addr>.  If equal set
-                        // ZF and load %EBX into <addr>.  Else, clear
-                        // ZF and load <addr> into %EAX.
-        jnz     L22
-
-
-        flds    _old_value(%ebp)
-                        // return old_value
-        popl    %ebx
-        popl    %esi
-        movl    %ebp, %esp
-        popl    %ebp
-        ret
-
-        DEBUG_INFO __kmp_test_then_add_real32
-
-//------------------------------------------------------------------------
-//
-// FUNCTION __kmp_test_then_add_real64
-//
-// kmp_real64
-// __kmp_test_then_add_real64( volatile kmp_real64 *addr, kmp_real64 data );
-//
-        PROC  __kmp_test_then_add_real64
-
-_addr = 8
-_data = 12
-_old_value = -8
-_new_value = -16
-
-        pushl   %ebp
-        movl    %esp, %ebp
-        subl    $16, %esp
-        pushl   %esi
-        pushl   %ebx
-        pushl   %ecx
-        pushl   %edx
-        movl    _addr(%ebp), %esi
-L44:
-        fldl    (%esi)
-                        // load <addr>
-        fstl    _old_value(%ebp)
-                        // store into old_value
-        faddl   _data(%ebp)
-        fstpl   _new_value(%ebp)
-                        // new_value = old_value + data
-
-        movl    _old_value+4(%ebp), %edx
-        movl    _old_value(%ebp), %eax
-                        // load old_value
-        movl    _new_value+4(%ebp), %ecx
-        movl    _new_value(%ebp), %ebx
-                        // load new_value
-
-	lock
-	cmpxchg8b (%esi)
-                        // Compare %EDX:%EAX with <addr>.  If equal set
-                        // ZF and load %ECX:%EBX into <addr>.  Else, clear
-                        // ZF and load <addr> into %EDX:%EAX.
-        jnz     L44
-
-
-        fldl    _old_value(%ebp)
-                        // return old_value
-        popl    %edx
-        popl    %ecx
-        popl    %ebx
-        popl    %esi
-        movl    %ebp, %esp
-        popl    %ebp
-        ret
-
-        DEBUG_INFO __kmp_test_then_add_real64
-
-
-//------------------------------------------------------------------------
-//
 // FUNCTION __kmp_load_x87_fpu_control_word
 //
 // void
@@ -758,30 +646,7 @@
 	.data
 	ALIGN 4
 
-// AC: The following #if hiden the .text thus moving the rest of code into .data section on MIC.
-// To prevent this in future .text added to every routine definition for x86_64.
-# if __MIC__ || __MIC2__
-
-# else
-
-//------------------------------------------------------------------------
-//
-// FUNCTION __kmp_x86_pause
-//
-// void
-// __kmp_x86_pause( void );
-//
-
-        .text
-        PROC  __kmp_x86_pause
-
-        pause_op
-        ret
-
-        DEBUG_INFO __kmp_x86_pause
-
-# endif // __MIC__ || __MIC2__
-
+// To prevent getting our code into .data section .text added to every routine definition for x86_64.
 //------------------------------------------------------------------------
 //
 // FUNCTION __kmp_x86_cpuid
@@ -1176,79 +1041,6 @@
 
 # if ! (__MIC__ || __MIC2__)
 
-//------------------------------------------------------------------------
-//
-// FUNCTION __kmp_test_then_add_real32
-//
-// kmp_real32
-// __kmp_test_then_add_real32( volatile kmp_real32 *addr, kmp_real32 data );
-//
-// parameters:
-// 	addr:	%rdi
-// 	data:	%xmm0 (lower 4 bytes)
-//
-// return:	%xmm0 (lower 4 bytes)
-
-        .text
-        PROC  __kmp_test_then_add_real32
-1:
-	movss   (%rdi), %xmm1	// load value of <addr>
-	movd	%xmm1, %eax	// save old value of <addr>
-
-	addss	%xmm0, %xmm1	// new value = old value + <data>
-	movd	%xmm1, %ecx	// move new value to GP reg.
-
-	lock
-	cmpxchgl %ecx, (%rdi)	// Compare %EAX with <addr>.  If equal set
-                             	// ZF and exchange %ECX with <addr>.  Else,
-                                // clear ZF and load <addr> into %EAX.
-        jz      2f
-	pause_op
-	jmp	1b
-2:
-	movd	%eax, %xmm0	// load old value into return register
-        ret
-
-        DEBUG_INFO __kmp_test_then_add_real32
-
-
-//------------------------------------------------------------------------
-//
-// FUNCTION __kmp_test_then_add_real64
-//
-// kmp_real64
-// __kmp_test_then_add_real64( volatile kmp_real64 *addr, kmp_real64 data );
-//
-// parameters:
-//      addr:   %rdi
-//      data:   %xmm0 (lower 8 bytes)
-//      return: %xmm0 (lower 8 bytes)
-//
-
-        .text
-        PROC  __kmp_test_then_add_real64
-1:
-        movlpd	(%rdi), %xmm1	// load value of <addr>
-	movd	%xmm1, %rax	// save old value of <addr>
-
-	addsd	%xmm0, %xmm1	// new value = old value + <data>
-	movd	%xmm1, %rcx	// move new value to GP reg.
-
-	lock
-	cmpxchgq  %rcx, (%rdi) 	// Compare %RAX with <addr>.  If equal set
-				// ZF and exchange %RCX with <addr>.  Else,
-				// clear ZF and load <addr> into %RAX.
-        jz      2f
-	pause_op
-	jmp     1b
-
-2:
-	movd	%rax, %xmm0	// load old value into return register
-        ret
-
-        DEBUG_INFO __kmp_test_then_add_real64
-
-
 # if !KMP_ASM_INTRINS
 
 //------------------------------------------------------------------------
@@ -1382,7 +1174,7 @@
 // typedef void	(*microtask_t)( int *gtid, int *tid, ... );
 //
 // int
-// __kmp_invoke_microtask( void (*pkfn) (int *gtid, int *tid, ...),
+// __kmp_invoke_microtask( void (*pkfn) (int gtid, int tid, ...),
 //		           int gtid, int tid,
 //                         int argc, void *p_argv[] ) {
 //    (*pkfn)( & gtid, & tid, argv[0], ... );
@@ -1597,5 +1389,9 @@
 #endif /* KMP_ARCH_PPC64 */
 
 #if defined(__linux__)
+# if KMP_ARCH_ARM
+.section .note.GNU-stack,"",%progbits
+# else
 .section .note.GNU-stack,"",@progbits
+# endif
 #endif
